#include <iostream>
#include <string>

using namespace std;

int main()
{
    int n, o, a, b, ab;
    cin >> n >> o >> a >> b >> ab;
    int pacijenti[n][4] = {0};

    for (int i = 0; i < n; i++) {
        string krvnaGrupa;
        int kolicinaKrvi;
        cin >> krvnaGrupa >> kolicinaKrvi;

        if (krvnaGrupa == "O") {
            if (o >= kolicinaKrvi) {
                o -= kolicinaKrvi;
                pacijenti[i][0] = kolicinaKrvi;
            } else {
                cout << "nemoguce";
                exit(1);
            }
        }
        else if (krvnaGrupa == "A") {
            if (o + a >= kolicinaKrvi) {
                if (a < kolicinaKrvi) {
                    o -= (kolicinaKrvi - a);
                    pacijenti[i][1] = a;
                    pacijenti[i][0] = kolicinaKrvi - a;
                    a = 0;
                } else {
                    a -= kolicinaKrvi;
                    pacijenti[i][1] = kolicinaKrvi;
                }
            } else {
                cout << "nemoguce";
                exit(1);
            }
        }
        else if (krvnaGrupa == "B") {
            if (o + b >= kolicinaKrvi) {
                if (b < kolicinaKrvi) {
                    o -= (kolicinaKrvi - b);
                    pacijenti[i][2] = b;
                    pacijenti[i][0] = kolicinaKrvi - b;
                    b = 0;
                } else {
                    b -= kolicinaKrvi;
                    pacijenti[i][1] = kolicinaKrvi;
                }
            } else {
                cout << "nemoguce";
                exit(1);
            }
        }
        else if (krvnaGrupa == "AB") {
            if (o + a + b + ab >= kolicinaKrvi) {
                if (ab < kolicinaKrvi) {
                    if (ab + b < kolicinaKrvi) {
                        if (ab + a < kolicinaKrvi) {
                            if (ab + a + b < kolicinaKrvi) {
                                o -= (kolicinaKrvi - (a + ab + b));
                                pacijenti[i][3] = ab;
                                pacijenti[i][2] = b;
                                pacijenti[i][1] = a;
                                pacijenti[i][0] = kolicinaKrvi - (ab + b + b);
                                ab = 0;
                                b = 0;
                                a = 0;
                            } else {
                                a -= (kolicinaKrvi - (a + ab));
                                pacijenti[i][3] = ab;
                                pacijenti[i][2] = b;
                                pacijenti[i][1] = kolicinaKrvi - (ab + b);
                                ab = 0;
                                b = 0;
                            }
                        } else {
                            a -= (kolicinaKrvi - ab);
                            pacijenti[i][3] = ab;
                            pacijenti[i][1] = kolicinaKrvi - ab;
                            ab = 0;
                        }
                    } else {
                        b -= (kolicinaKrvi - ab);
                        pacijenti[i][3] = ab;
                        pacijenti[i][2] = kolicinaKrvi - ab;
                        ab = 0;
                    }
                } else {
                    ab -= kolicinaKrvi;
                    pacijenti[i][3] = kolicinaKrvi;
                }
            } else {
                cout << "nemoguce";
                exit(1);
            }
        }
    }

    cout << "moguce" << endl;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 4; j++) {
            cout << pacijenti[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}